/** @(#) listpos/cpplistpos.h */
/**
* Implementa una lista basandose en <vector>.
* @author Omar Posada Villarreal
* @version 2.1, 10/12/2001 C++ getLast()
* @version 2.0, 10/12/2001 C++
* @version 1.1, 15/10/2001 getFirst(), getNext()
* @version 1.0, 03/10/2001
*/

#ifndef CPPLISTPOS_H
#define CPPLISTPOS_H
//----------------------------------------------------------------------------
#include "listexceptionpos.h"
#include "listpos.h"	// padre
#include <vector>	// existe tambien <list>, pero es menos funcional

/**
* Implementa una lista basandose en <vector>.
* @author Omar Posada Villarreal
* @version 1.2, 10/12/2001 C++
* @version 1.1, 15/10/2001 getFirst(), getNext()
* @version 1.0, 03/10/2001
*/
template <class TObj>
class CppListPos : public ListPos<TObj> {	// public muestra miembros
//error	friend ostream& operator<<(
//         	ostream &outStr, const CppListPos<TObj> &list); // ???const <TObj>
public:
        // Constructor sin elementos, capacidad predeterminada
	CppListPos();
	~CppListPos();	// Destructor. Libera memoria.

        int size() const;
	bool isEmpty() const;
	bool isFull() const;
	void print() const;

        void addFirst(const TObj item) throw (FullListExceptionPos);
	void addLast(const TObj item) throw (FullListExceptionPos);
	TObj removeFirst() throw(EmptyListExceptionPos);
	TObj removeLast() throw(EmptyListExceptionPos);
	void removeAllElements();

        TObj getLast() throw(EmptyListExceptionPos);

private:
	/** Conjunto de elementos. */
	vector<TObj>	list;
};
//----------------------------------------------------------------------------
#endif
// Fin------------------------------------------------------------------------

