/** @(#) listpos/dlinknodepos.cpp */
/**
* Almacena al nodo de la lista dinamica doblemente ligada.
* @author Omar Posada Villarreal
* @version 2.0, 02/01/2002 C++
* @version 1.0, 26/10/2001
*/
#include "dlinknodepos.h"

// constructor, ~, friend-----------------------------------------------------

/**
* Constructor. Crea un nodo conteniendo a un "TObj".
* Usado cuando la lista esta vacia.
* @param element Dato o item a insertar.
*/
template <class TObj>
DLinkNodePos<TObj> :: DLinkNodePos(TObj element) {
	item	= element;
	left	= NULL;
	right	= NULL;
}

/**
* Constructor. Liga el nuevo elemento con la lista.
* @param element Dato o item a insertar.
* @param nextNode Nodo para conectarlo antes.
*/
/*template <class TObj> DLinkNodePos<TObj> ::
DLinkNodePos(TObj element, DLinkNodePos *nextNode) {
	item = element;
	next = nextNode;
}
*/

/* Destructor predeterminado. */
/* Libera recursos. */

// public---------------------------------------------------------------------

/**
* Regresa el contenido del nodo actual.
* @return Contenido del objeto.
*/
template <class TObj>
TObj DLinkNodePos<TObj> :: getItem() const {
	return item;
}

/**
* Devuelve la referencia al nodo anterior al actual (izquierda).
* @return Regresa el nodo anterior. null: Si no hay nodo.
*/
template <class TObj>
DLinkNodePos<TObj> *  DLinkNodePos<TObj> :: getLeft() const {	// dificil
	return left;
}

/**
* Devuelve la referencia al siguiente nodo del actual (derecha).
* @return Regresa el siguiente nodo. null: Si no hay nodo.
*/
template <class TObj>
DLinkNodePos<TObj> *  DLinkNodePos<TObj> :: getRight() const {	// dificil
	return right;
}

/**
* Cambia el apuntador al elemento anterior (izquierda).
* Modifica el apuntador al nodo anterior al actual.
* @param theLEft Nuevo apuntador.
*/
template <class TObj>
void DLinkNodePos<TObj> :: setLeft(DLinkNodePos<TObj> *theLeft) {
	left = theLeft;
}

/**
* Cambia el apuntador al siguiente elemento (derecha).
* Modifica el apuntador al nodo que le sigue al actual.
* @param theRight Nuevo apuntador.
*/
template <class TObj>
void DLinkNodePos<TObj> :: setRight(DLinkNodePos<TObj> *theRight) {
	right = theRight;
}

// Fin------------------------------------------------------------------------






