/** @(#) listpos/listexceptionpos.h */
/**
* Conjunto de excepciones de las listas.
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
*/
#ifndef LISTEXCEPTIONPOS_H
#define LISTEXCEPTIONPOS_H
//----------------------------------------------------------------------------
#include <iostream>
#include <string>
using namespace std;

/**
* Conjunto de excepciones de las listas.
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
*/
class ListExceptionPos {
public:	/** Construye una excepcion para listas. */
        ListExceptionPos()
        	: message ("Excepcion en la lista.") {
        }
	/**
        * Construye una excepcion para listas.
        * @param theMessage Mensaje a mostrar.
        */
        ListExceptionPos(string theMessage)
        	: message (theMessage) {
        }
        /** Regresa el mensaje especifico. */
        const string what() const {
        	return message;
        }
private:	// No se pudo heredar modificacion
	const string message;
};
//----------------------------------------------------------------------------
/**
* Cuando la lista esta vacia.
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
*/
class EmptyListExceptionPos : public ListExceptionPos {
public:	/** Construye una excepcion para lista vacia. */
        EmptyListExceptionPos() : message("Lista vacia.") {
        }
	/**
        * Construye una excepcion para lista vacia.
        * @param theMessage Mensaje a mostrar.
        */
        EmptyListExceptionPos(string theMessage)
        	: message (theMessage) {
        }
        /** Regresa el mensaje especifico. */
        const string what() const {
        	return message;
        }
private:
	const string message;
};
//----------------------------------------------------------------------------
/**
* Cuando la lista esta llena.
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
*/
class FullListExceptionPos : public ListExceptionPos {
public:	/** Construye una excepcion para lista llena. */
        FullListExceptionPos() : message("Lista llena.") {
        }
	/**
        * Construye una excepcion para lista llena.
        * @param theMessage Mensaje a mostrar.
        */
        FullListExceptionPos(string theMessage)
        	: message (theMessage) {
        }
        /** Regresa el mensaje especifico. */
        const string what() const {
        	return message;
        }
private:
	const string message;
};

/*HELP
Siguiente version heredar de runtime_error
class exception {
   public:
     exception () throw();
     exception (const exception&) throw();
     exception& operator= (const exception&) throw();
     virtual ~exception () throw();
     virtual const char* what () const throw();
 };

 class range_error : public runtime_error {
   public:

     explicit range_error (const string& what_arg);
 };
*/

//----------------------------------------------------------------------------

#endif
// Fin------------------------------------------------------------------------
