/** @(#) listpos/listnodepos.cpp */
/**
* Almacena al nodo de la lista dinamica.
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
* @version 1.0, 03/10/2001
*/
#include "listnodepos.h"

// constructor, ~, friend-----------------------------------------------------

/**
* Constructor. Crea un nodo conteniendo a un "TObj".
* Usado cuando la lista esta vacia.
* @param element Dato o item a insertar.
*/
template <class TObj>
ListNodePos<TObj> :: ListNodePos(TObj element) {
	item	= element;
	next	= NULL;
}

/**
* Constructor. Liga el nuevo elemento con la lista.
* @param element Dato o item a insertar.
* @param nextNode Nodo para conectarlo antes.
*/
template <class TObj> ListNodePos<TObj> ::
ListNodePos(TObj element, ListNodePos *nextNode) {
	item = element;
	next = nextNode;
}

/* Destructor predeterminado. */
/* Libera recursos. */

// public---------------------------------------------------------------------

/**
* Regresa el contenido del nodo actual.
* @return Contenido del objeto.
*/
template <class TObj>
TObj ListNodePos<TObj> :: getItem() {
	return item;
}

/**
* Devuelve la referencia al nodo que le sigue al actual.
* @return Regresa el siguiente nodo. null: Si no hay nodo.
*/
template <class TObj>
ListNodePos<TObj> *  ListNodePos<TObj> :: getNext() {	// dificil
	return next;
}
// } ok

/**
* Cambia el apuntador al siguiente elemento.
* Modifica el apuntador al nodo que le sigue al actual.
* @param theNext Nuevo apuntador.
*/
template <class TObj>
void ListNodePos<TObj> :: setNext(ListNodePos<TObj> *theNext) {
	next = theNext;
}

// Fin------------------------------------------------------------------------






