/** @(#) listpos/queuepos.h */
/**
* Implementa los metodos comunes a las colas.
* Representacion "LIFO", ultimo en entrar, primero en salir 
* ("Last in, first out").
* Usa las implementaciones de "ListPos".
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
* @version 1.0, 03/10/2001
*/

#ifndef QUEUEPOS_H
#define QUEUEPOS_H
//----------------------------------------------------------------------------
#include "listpos.h"
#include "listexceptionpos.h"
#include <iostream>
#include <string>
using namespace std;

/**
* Implementa los metodos comunes a las colas.
* Representacion "LIFO", ultimo en entrar, primero en salir 
* ("Last in, first out").
* Usa las implementaciones de "ListPos".
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
* @version 1.0, 03/10/2001
*/
template <class TObj>
class QueuePos {
public:
	QueuePos(ListPos<TObj> *pTheList); // Inicializa el tipo de lista
	// Destructor predeterminado. La lista libera memoria
        int size() const;
	bool isEmpty() const;
	bool isFull() const;
	void print() const;

	void removeAllElements();

        void queue(const TObj item) throw (FullListExceptionPos);
	TObj dequeue() throw(EmptyListExceptionPos);
private:
	ListPos<TObj> *pList;
};
//----------------------------------------------------------------------------
#endif
// Fin------------------------------------------------------------------------

